//
//  AppDelegate.h
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 09/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "XMPP.h"
#import "XMPPRoster.h"
#import "XMPPRosterMemoryStorage.h"

#import "Model/ContactsManager.h"
#import "ContactsViewDelegate.h"

#import "Model/ChatsManager.h"
#import "ChatsViewDelegate.h"

#import "TFCConfig.h"

@class ChatsViewController;

@interface AppDelegate : UIResponder <UIApplicationDelegate>
{
    UIWindow *window;
    XMPPStream *xmppStream;
    XMPPRoster *xmppRoster;
    NSString *password;
    BOOL isOpen;
    BOOL connectionStartedByLogin;
    
    NSString *activeUserChat;
    
    XMPPRosterMemoryStorage *rosterstorage;
    
    TFCConfig *mainConfig;
    
    ContactsManager *contactsDelegate;
    ChatsManager *chatsDelegate;
    __unsafe_unretained NSObject <ContactsViewDelegate> *contactsViewDelegate;
    __unsafe_unretained NSObject <ChatsViewDelegate> *chatsViewDelegate;

}

@property NSString *activeUserChat;

@property BOOL didOnlineByLoggin;
@property BOOL canRegisterUser;

@property (strong, nonatomic) UIWindow *window;
@property XMPPStream *xmppStream;
@property  XMPPRoster *xmppRoster;

@property (strong, nonatomic) TFCConfig *mainConfig;

@property (strong, nonatomic) ContactsManager *contactsDelegate;
@property (strong, nonatomic) ChatsManager *chatsDelegate;
@property (nonatomic, assign) id  contactsViewDelegate;
@property (nonatomic, assign) id  chatsViewDelegate;

- (BOOL)connectForLogin;
- (BOOL)connectForRegister;
- (BOOL)connect;
- (void)disconnect;

@end






