//
//  ContactsViewController.m
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 09/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//

#import "ContactsViewController.h"
#import "XMPP.h"
#import "XMPPRoster.h"

@implementation ContactsViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.tView.delegate = self;
    self.tView.dataSource = self;
    AppDelegate *del = [self appDelegate];
    del.contactsViewDelegate = self;
    [self.tView reloadData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@synthesize tView;


- (AppDelegate *)appDelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}

- (NSMutableArray *)contacts
{
    return [[[self appDelegate] contactsDelegate] contacts];
}

- (XMPPStream *)xmppStream {
    return [[self appDelegate] xmppStream];
}

- (XMPPRoster *)xmppRoster {
    return [[self appDelegate] xmppRoster];
}

- (IBAction) addContact {
    
    [self performSegueWithIdentifier:@"DoAddContact" sender:self];
}

#pragma mark -
#pragma mark Table view delegates

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    NSString *s = (NSString *) [[self contacts] objectAtIndex:indexPath.row];
    
    static NSString *CellIdentifier = @"UserCellIdentifier";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    cell.textLabel.text = s;
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    
    return cell;
    
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return [[self contacts] count];
    
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    
    return 1;
    
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    NSString *userName = (NSString *) [[self contacts] objectAtIndex:indexPath.row];
    [self appDelegate].activeUserChat = userName;
    [self performSegueWithIdentifier:@"OpenChat" sender:self];
}

#pragma mark -
#pragma mark Chat delegate

- (void)UserOnline:(NSString *)name {
    
    if ([[self contacts] containsObject:name]) {
        
        [self.tView reloadData];
        
    }
    
}

- (void)UserOffline:(NSString *)name {
    
    [self.tView reloadData];
    
}

- (void)didDisconnect {
    
    [self.tView reloadData];
    
}




@end
