//
//  ContactsManager.h
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 10/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//
/*
This model class represents the state of contacts in the application. It's a direct dependence to it.
 By now, ContactsManager is a sotrage delegate for the contacts that are online.
 When a presence is received with the apropiated parameters, userOnline os Offlline is called.
 This class becomes the dataSource for a view (UITableView).
 */
//

#ifndef ContactsManager_h
#define ContactsManager_h

#import <Foundation/Foundation.h>

@interface ContactsManager: NSObject
{
    NSMutableArray *contacts;
}

@property (strong, nonatomic) NSMutableArray *contacts;

- (void)UserOnline:(NSString *)name;
- (void)UserOffline:(NSString *)name;
- (void)didDisconnect;

@end

#endif
