//
//  ContactsManager.m
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 10/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//
//
/*
 This model class represents the state of contacts in the application. It's a direct dependence to it.
 By now, ContactsManager is a sotrage delegate for the contacts that are online.
 When a presence is received with the apropiated parameters, userOnline os Offlline is called.
 This class becomes the dataSource for a view (UITableView).
 */
//

#import "ContactsManager.h"

@implementation ContactsManager

@synthesize contacts;

-(id)init
{
    self = [super init];
    contacts = [[NSMutableArray alloc ] init];
    return self;
}

#pragma mark -
#pragma mark Chat delegate

- (void)UserOnline:(NSString *)name {
    
    if (![contacts containsObject:name]) {
        
        [contacts addObject:name];
    }
    
}

- (void)UserOffline:(NSString *)name {
    
    [contacts removeObject:name];
    
}

- (void)didDisconnect {
    
    [contacts removeAllObjects];
    
}

@end

