//
//  TFCChat.h
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 10/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//
/* This class represents a chat with its messages and user implied.
 It becames a message list controller that proxyes the readed state to them and it's able to add new messages.
 Messages come from outside because we want to be able to create them from user input, connection input or local storage input(history).
 Chats becames linked to a view as a message data source (UITableView).
 */
//

#ifndef TFCChat_h
#define TFCChat_h

#import <Foundation/Foundation.h>
#import "TFCMessage.h"
#import "ActiveChatViewDelegate.h"

@interface TFCChat: NSObject
{
    NSMutableArray *messages;
    NSString *user;
    
    __unsafe_unretained NSObject <ActiveChatViewDelegate> *delegateView;
}

@property (strong, nonatomic) NSMutableArray *messages;
@property (strong, nonatomic) NSString *user;

@property (nonatomic, assign) id  delegateView;


- (id)initWithUser:(NSString *)puser;
- (void)AddMessage:(TFCMessage *)oMessage;

- (NSString *)getChatDescription;
- (NSInteger)getNumberOfMessages;
-(void)Readed;

@end

#endif
