//
//  TFCChat.m
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 10/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//
//
/* This class represents a chat with its messages and user implied.
 It becames a message list controller that proxyes the readed state to them and it's able to add new messages.
 Messages come from outside because we want to be able to create them from user input, connection input or local storage input(history).
 Chats becames linked to a view as a message data source (UITableView).
 */
//

#import "TFCChat.h"

@implementation TFCChat

@synthesize messages, delegateView, user;

- (id)initWithUser:(NSString *)puser
{
    self = [super init];
    user = puser;
    messages = [[NSMutableArray alloc] init];
    return self;
}

#pragma mark -
#pragma mark Chat delegate

- (void)AddMessage:(TFCMessage *)oMessage
{
    [messages addObject:oMessage];
    [delegateView NewMessage:oMessage];
}

//For the view that wants to see: "User (#newMsgs)"
- (NSString *)getChatDescription
{
    NSInteger count = [self getNumberOfNewMessages];
    NSString *description;
    if (count > 0)
    {
        description = [NSString stringWithFormat:@"%@ (%ld)",[self user],(long)count];
    }
    else
    {
        description = [self user];
    }
    return description;
}

- (NSInteger)getNumberOfNewMessages
{
    NSInteger count = 0;
    for (TFCMessage *message in messages)
    {
        if ([message isNew]) count++;
    }
    return count;
}

- (NSInteger)getNumberOfMessages
{
    return messages.count;
}

-(void)Readed
{
    for (TFCMessage *message in messages)
    {
        [message Readed];
    }
}


@end

