//
//  TFCTableCell.m (Based on XMPP example)
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 10/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//
/*
 A Special derivated table Cell that sets some subviews to reach the bubble view:
 -bgImageView: To have a bubble color ans shape.
 -senderAndTimeLabel: Sets a user and timestamp description
 -messageContentView: The message itself
 */
//

#import "TFCTableCell.h"


@implementation TFCTableCell

@synthesize senderAndTimeLabel, messageContentView, bgImageView;

- (void)dealloc {
}

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    
	if (self = [super initWithStyle:style reuseIdentifier:reuseIdentifier]) {

		senderAndTimeLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, 5, 300, 20)];
		senderAndTimeLabel.textAlignment = UITextAlignmentCenter;
		senderAndTimeLabel.font = [UIFont systemFontOfSize:11.0];
		senderAndTimeLabel.textColor = [UIColor lightGrayColor];
		[self.contentView addSubview:senderAndTimeLabel];
		
		bgImageView = [[UIImageView alloc] initWithFrame:CGRectZero];
		[self.contentView addSubview:bgImageView];
		
		messageContentView = [[UITextView alloc] init];
		messageContentView.backgroundColor = [UIColor clearColor];
		messageContentView.editable = NO;
		messageContentView.scrollEnabled = NO;
		[messageContentView sizeToFit];
		[self.contentView addSubview:messageContentView];
    }
	
    return self;
	
}








@end
