//
//  TFCConnectionTest.m
//  rrrt
//
//  Created by Silvia Cabezas Nieto on 18/05/15.
//  Copyright (c) 2015 Silvia Cabezas Nieto. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <XCTest/XCTest.h>
#import "AppDelegate.h"

@interface TFCConnectionTest : XCTestCase
{
    AppDelegate *appDelgate;
}

@end

@implementation TFCConnectionTest



- (void)setUp {
    [super setUp];
    appDelgate = [[AppDelegate alloc] init];
}

- (void)tearDown {
    appDelgate = nil;
    [super tearDown];
}

static NSString *ADMINUSER = @"admin";
static NSString *ADMINPASS = @"devil";

- (void)testConnectionMethodSucces
{
    [[NSUserDefaults standardUserDefaults] setObject:ADMINUSER forKey:@"userID"];
    [[NSUserDefaults standardUserDefaults] setObject:ADMINPASS forKey:@"userPassword"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
    XCTAssert([appDelgate connect], @"connection executed");

}

- (void)testConnectionMethodFail
{
    [[NSUserDefaults standardUserDefaults] setObject:nil forKey:@"userID"];
    [[NSUserDefaults standardUserDefaults] setObject:nil forKey:@"userPassword"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
    XCTAssert(![appDelgate connect], @"controlled connection failed");
    
}

- (void)testConnectionMethodReturnOfControlTimePerformance {
    
    [self measureBlock:^{
        
        [[NSUserDefaults standardUserDefaults] setObject:ADMINUSER forKey:@"userID"];
        [[NSUserDefaults standardUserDefaults] setObject:ADMINPASS forKey:@"userPassword"];
        [[NSUserDefaults standardUserDefaults] synchronize];
        
        [appDelgate connect];
    }];
}

@end
